---
title: IDBLocaleAwareKeyRange
slug: Web/API/IDBLocaleAwareKeyRange
tags:
  - API
  - Database
  - Experimental
  - IDBKeyRange
  - IndexedDB
  - Interface
  - Reference
  - Storage
---
<div>{{non-standard_header}}{{APIRef("IndexedDB")}}{{SeeCompatTable}}</div>

<p>The <strong><code>IDBLocaleAwareKeyRange</code></strong> interface of the <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB API</a> is a Firefox-specific version of {{domxref("IDBKeyRange")}} — it functions in exactly the same fashion, and has the same properties and methods, but it is intended for use with {{domxref("IDBIndex")}} objects when the original index had a <code>locale</code> value specified upon its creation (see <a href="/en-US/docs/Web/API/IDBObjectStore/createIndex#Parameters"><code>createIndex()</code>'s optionalParameters</a>) — that is, it has <a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB#Locale-aware_sorting">locale aware sorting</a> enabled.</p>

<h2 id="Methods">Methods</h2>

<p><em>This interface inherits all the methods of its parent interface, {{domxref("IDBKeyRange")}}.</em></p>

<h2 id="Properties">Properties</h2>

<p><em>This interface inherits all the properties of its parent interface, {{domxref("IDBKeyRange")}}.</em></p>

<p>Bear in mind however that <code>IDBLocaleAwareKeyRange</code> has its own implementation of {{domxref("IDBKeyRange.bound")}}. This is because when you use <code>bound()</code>, it checks if lower bound &lt; upper bound, and throws an exception if that’s not the case. With locale-aware indexes, the meaning of &lt; depends on the locale, so for example in Lithuanian Y is sorted between I and K. The only difference between <code>IDBKeyRange</code> and <code>IDBLocaleAwareKeyRange</code> is that the latter doesn’t do the aforementioned check.</p>

<p>Developers should always use <code>IDBLocaleAwareKeyRange</code> when dealing with locale-aware indexes.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">function displayData() {
  var keyRangeValue = IDBLocaleAwareKeyRange.bound("A", "F");

  var transaction = db.transaction(['fThings'], 'readonly');
  var objectStore = transaction.objectStore('fThings');

  var myIndex = objectStore.index('lName');
  myIndex.openCursor(keyRangeValue).onsuccess = function(event) {
    var cursor = event.target.result;
    if(cursor) {
      var tableRow = document.createElement('tr');
      tableRow.innerHTML =   '&amp;lt;td&amp;gt;' + cursor.value.id + '&amp;lt;/td&amp;gt;'
                           + '&amp;lt;td&amp;gt;' + cursor.value.lName + '&amp;lt;/td&amp;gt;'
                           + '&amp;lt;td&amp;gt;' + cursor.value.fName + '&amp;lt;/td&amp;gt;'
                           + '&amp;lt;td&amp;gt;' + cursor.value.jTitle + '&amp;lt;/td&amp;gt;'
                           + '&amp;lt;td&amp;gt;' + cursor.value.company + '&amp;lt;/td&amp;gt;'
                           + '&amp;lt;td&amp;gt;' + cursor.value.eMail + '&amp;lt;/td&amp;gt;'
                           + '&amp;lt;td&amp;gt;' + cursor.value.phone + '&amp;lt;/td&amp;gt;'
                           + '&amp;lt;td&amp;gt;' + cursor.value.age + '&amp;lt;/td&amp;gt;';
      tableEntry.appendChild(tableRow);

      cursor.continue();
    } else {
      console.log('Entries all displayed.');
    }
  };
};</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not currently part of any specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBLocaleAwareKeyRange")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
